/**
 * 
 */
package org.queryall.impl.profile;

import java.util.Collection;

import org.openrdf.OpenRDFException;
import org.openrdf.model.Statement;
import org.openrdf.model.URI;
import org.queryall.api.profile.Profile;
import org.queryall.api.profile.ProfileParser;

/**
 * @author Peter Ansell p_ansell@yahoo.com
 */
public class ProfileImplParser implements ProfileParser
{
    @Override
    public Profile createObject(final Collection<Statement> rdfStatements, final URI subjectKey, final int modelVersion)
        throws IllegalArgumentException
    {
        try
        {
            return new ProfileImpl(rdfStatements, subjectKey, modelVersion);
        }
        catch(final OpenRDFException ex)
        {
            throw new IllegalArgumentException("Could not parse the given RDF statements into a profile", ex);
        }
    }
}
